Chapter 14. ComplianceService
14.1. GetAggregatedResults Copy linkLink copied to clipboard!
GET /v1/compliance/aggregatedresults
14.1.1. Description Copy linkLink copied to clipboard!
14.1.2. Parameters Copy linkLink copied to clipboard!
14.1.2.1. Query Parameters Copy linkLink copied to clipboard!
| Name | Description | Required | Default | Pattern |
|---|---|---|---|---|
| groupBy |
| - | null | |
| unit | - | UNKNOWN | ||
| where.query | - | null | ||
| where.pagination.limit | - | null | ||
| where.pagination.offset | - | null | ||
| where.pagination.sortOption.field | - | null | ||
| where.pagination.sortOption.reversed | - | null | ||
| where.pagination.sortOption.aggregateBy.aggrFunc | - | UNSET | ||
| where.pagination.sortOption.aggregateBy.distinct | - | null |
14.1.3. Return Type Copy linkLink copied to clipboard!
14.1.4. Content Type Copy linkLink copied to clipboard!
- application/json
14.1.5. Responses Copy linkLink copied to clipboard!
| Code | Message | Datatype |
|---|---|---|
| 200 | A successful response. | |
| 0 | An unexpected error response. |
14.1.6. Samples Copy linkLink copied to clipboard!
14.1.7. Common object reference Copy linkLink copied to clipboard!
14.1.7.1. ComplianceAggregationAggregationKey Copy linkLink copied to clipboard!
Next available tag: 3
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| scope | UNKNOWN, STANDARD, CLUSTER, CATEGORY, CONTROL, NAMESPACE, NODE, DEPLOYMENT, CHECK, | ||||
| id | String |
14.1.7.2. ProtobufAny Copy linkLink copied to clipboard!
Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.
Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.
Example 1: Pack and unpack a message in C++.
Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
...
}
Example 2: Pack and unpack a message in Java.
Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
any.Unpack(foo)
...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
...
}
The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".
14.1.7.2.1. JSON representation Copy linkLink copied to clipboard!
The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:
package google.profile;
message Person {
string first_name = 1;
string last_name = 2;
}
{
"@type": "type.googleapis.com/google.profile.Person",
"firstName": <string>,
"lastName": <string>
}
If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):
{
"@type": "type.googleapis.com/google.protobuf.Duration",
"value": "1.212s"
}
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| typeUrl | String |
A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in | |||
| value | byte[] | Must be a valid serialized protocol buffer of the above specified type. | byte |
14.1.7.3. RuntimeError Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| error | String | ||||
| code | Integer | int32 | |||
| message | String | ||||
| details | List of ProtobufAny |
14.1.7.4. StorageComplianceAggregationResponse Copy linkLink copied to clipboard!
Next available tag: 3
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| results | |||||
| sources | |||||
| errorMessage | String |
14.1.7.5. StorageComplianceAggregationResult Copy linkLink copied to clipboard!
Next available tag: 5
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| aggregationKeys | |||||
| unit | UNKNOWN, STANDARD, CLUSTER, CATEGORY, CONTROL, NAMESPACE, NODE, DEPLOYMENT, CHECK, | ||||
| numPassing | Integer | int32 | |||
| numFailing | Integer | int32 | |||
| numSkipped | Integer | int32 |
14.1.7.6. StorageComplianceAggregationScope Copy linkLink copied to clipboard!
| Enum Values |
|---|
| UNKNOWN |
| STANDARD |
| CLUSTER |
| CATEGORY |
| CONTROL |
| NAMESPACE |
| NODE |
| DEPLOYMENT |
| CHECK |
14.1.7.7. StorageComplianceAggregationSource Copy linkLink copied to clipboard!
Next available tag: 5
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| clusterId | String | ||||
| standardId | String | ||||
| successfulRun | |||||
| failedRuns | List of StorageComplianceRunMetadata |
14.1.7.8. StorageComplianceRunMetadata Copy linkLink copied to clipboard!
Next available tag: 5
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| runId | String | ||||
| standardId | String | ||||
| clusterId | String | ||||
| startTimestamp | Date | date-time | |||
| finishTimestamp | Date | date-time | |||
| success | Boolean | ||||
| errorMessage | String | ||||
| domainId | String |
14.2. GetRunResults Copy linkLink copied to clipboard!
GET /v1/compliance/runresults
14.2.1. Description Copy linkLink copied to clipboard!
14.2.2. Parameters Copy linkLink copied to clipboard!
14.2.2.1. Query Parameters Copy linkLink copied to clipboard!
| Name | Description | Required | Default | Pattern |
|---|---|---|---|---|
| clusterId | - | null | ||
| standardId | - | null | ||
| runId | Specifies the run ID for which to return results. If empty, the most recent run is returned. CAVEAT: Setting this field circumvents the results cache on the server-side, which may lead to significantly increased memory pressure and decreased performance. | - | null |
14.2.3. Return Type Copy linkLink copied to clipboard!
14.2.4. Content Type Copy linkLink copied to clipboard!
- application/json
14.2.5. Responses Copy linkLink copied to clipboard!
| Code | Message | Datatype |
|---|---|---|
| 200 | A successful response. | |
| 0 | An unexpected error response. |
14.2.6. Samples Copy linkLink copied to clipboard!
14.2.7. Common object reference Copy linkLink copied to clipboard!
14.2.7.1. ComplianceResultValueEvidence Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| state | COMPLIANCE_STATE_UNKNOWN, COMPLIANCE_STATE_SKIP, COMPLIANCE_STATE_NOTE, COMPLIANCE_STATE_SUCCESS, COMPLIANCE_STATE_FAILURE, COMPLIANCE_STATE_ERROR, | ||||
| message | String | ||||
| messageId | Integer | int32 |
14.2.7.2. ComplianceRunResultsEntityResults Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| controlResults | Map of StorageComplianceResultValue |
14.2.7.3. ProtobufAny Copy linkLink copied to clipboard!
Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.
Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.
Example 1: Pack and unpack a message in C++.
Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
...
}
Example 2: Pack and unpack a message in Java.
Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
any.Unpack(foo)
...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
...
}
The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".
14.2.7.3.1. JSON representation Copy linkLink copied to clipboard!
The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:
package google.profile;
message Person {
string first_name = 1;
string last_name = 2;
}
{
"@type": "type.googleapis.com/google.profile.Person",
"firstName": <string>,
"lastName": <string>
}
If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):
{
"@type": "type.googleapis.com/google.protobuf.Duration",
"value": "1.212s"
}
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| typeUrl | String |
A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in | |||
| value | byte[] | Must be a valid serialized protocol buffer of the above specified type. | byte |
14.2.7.4. RuntimeError Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| error | String | ||||
| code | Integer | int32 | |||
| message | String | ||||
| details | List of ProtobufAny |
14.2.7.5. StorageComplianceDomain Copy linkLink copied to clipboard!
Next available tag: 5
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| cluster | |||||
| nodes | Map of StorageComplianceDomainNode | ||||
| deployments |
14.2.7.6. StorageComplianceDomainCluster Copy linkLink copied to clipboard!
These must mirror the tags _exactly_ in cluster.proto for backwards compatibility
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| name | String |
14.2.7.7. StorageComplianceDomainDeployment Copy linkLink copied to clipboard!
This must mirror the tags _exactly_ in deployment.proto for backwards compatibility
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| name | String | ||||
| type | String | ||||
| namespace | String | ||||
| namespaceId | String | ||||
| clusterId | String | ||||
| clusterName | String |
14.2.7.8. StorageComplianceDomainNode Copy linkLink copied to clipboard!
These must mirror the tags _exactly_ in node.proto for backwards compatibility
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| name | String | ||||
| clusterId | String | ||||
| clusterName | String |
14.2.7.9. StorageComplianceResultValue Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| evidence | List of ComplianceResultValueEvidence | ||||
| overallState | COMPLIANCE_STATE_UNKNOWN, COMPLIANCE_STATE_SKIP, COMPLIANCE_STATE_NOTE, COMPLIANCE_STATE_SUCCESS, COMPLIANCE_STATE_FAILURE, COMPLIANCE_STATE_ERROR, |
14.2.7.10. StorageComplianceRunMetadata Copy linkLink copied to clipboard!
Next available tag: 5
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| runId | String | ||||
| standardId | String | ||||
| clusterId | String | ||||
| startTimestamp | Date | date-time | |||
| finishTimestamp | Date | date-time | |||
| success | Boolean | ||||
| errorMessage | String | ||||
| domainId | String |
14.2.7.11. StorageComplianceRunResults Copy linkLink copied to clipboard!
Next available tag: 6
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| domain | |||||
| runMetadata | |||||
| clusterResults | |||||
| nodeResults | |||||
| deploymentResults | |||||
| machineConfigResults |
14.2.7.12. StorageComplianceState Copy linkLink copied to clipboard!
| Enum Values |
|---|
| COMPLIANCE_STATE_UNKNOWN |
| COMPLIANCE_STATE_SKIP |
| COMPLIANCE_STATE_NOTE |
| COMPLIANCE_STATE_SUCCESS |
| COMPLIANCE_STATE_FAILURE |
| COMPLIANCE_STATE_ERROR |
14.2.7.13. V1GetComplianceRunResultsResponse Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| results | |||||
| failedRuns | List of StorageComplianceRunMetadata |
14.3. GetStandards Copy linkLink copied to clipboard!
GET /v1/compliance/standards
14.3.1. Description Copy linkLink copied to clipboard!
14.3.2. Parameters Copy linkLink copied to clipboard!
14.3.3. Return Type Copy linkLink copied to clipboard!
14.3.4. Content Type Copy linkLink copied to clipboard!
- application/json
14.3.5. Responses Copy linkLink copied to clipboard!
| Code | Message | Datatype |
|---|---|---|
| 200 | A successful response. | |
| 0 | An unexpected error response. |
14.3.6. Samples Copy linkLink copied to clipboard!
14.3.7. Common object reference Copy linkLink copied to clipboard!
14.3.7.1. ProtobufAny Copy linkLink copied to clipboard!
Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.
Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.
Example 1: Pack and unpack a message in C++.
Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
...
}
Example 2: Pack and unpack a message in Java.
Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
any.Unpack(foo)
...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
...
}
The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".
14.3.7.1.1. JSON representation Copy linkLink copied to clipboard!
The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:
package google.profile;
message Person {
string first_name = 1;
string last_name = 2;
}
{
"@type": "type.googleapis.com/google.profile.Person",
"firstName": <string>,
"lastName": <string>
}
If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):
{
"@type": "type.googleapis.com/google.protobuf.Duration",
"value": "1.212s"
}
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| typeUrl | String |
A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in | |||
| value | byte[] | Must be a valid serialized protocol buffer of the above specified type. | byte |
14.3.7.2. RuntimeError Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| error | String | ||||
| code | Integer | int32 | |||
| message | String | ||||
| details | List of ProtobufAny |
14.3.7.3. V1ComplianceStandardMetadata Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| name | String | ||||
| description | String | ||||
| numImplementedChecks | Integer | int32 | |||
| scopes | |||||
| dynamic | Boolean | ||||
| hideScanResults | Boolean |
14.3.7.4. V1ComplianceStandardMetadataScope Copy linkLink copied to clipboard!
| Enum Values |
|---|
| UNSET |
| CLUSTER |
| NAMESPACE |
| DEPLOYMENT |
| NODE |
14.3.7.5. V1GetComplianceStandardsResponse Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| standards | List of V1ComplianceStandardMetadata |
14.4. GetStandard Copy linkLink copied to clipboard!
GET /v1/compliance/standards/{id}
14.4.1. Description Copy linkLink copied to clipboard!
14.4.2. Parameters Copy linkLink copied to clipboard!
14.4.2.1. Path Parameters Copy linkLink copied to clipboard!
| Name | Description | Required | Default | Pattern |
|---|---|---|---|---|
| id | X | null |
14.4.3. Return Type Copy linkLink copied to clipboard!
14.4.4. Content Type Copy linkLink copied to clipboard!
- application/json
14.4.5. Responses Copy linkLink copied to clipboard!
| Code | Message | Datatype |
|---|---|---|
| 200 | A successful response. | |
| 0 | An unexpected error response. |
14.4.6. Samples Copy linkLink copied to clipboard!
14.4.7. Common object reference Copy linkLink copied to clipboard!
14.4.7.1. ProtobufAny Copy linkLink copied to clipboard!
Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.
Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.
Example 1: Pack and unpack a message in C++.
Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
...
}
Example 2: Pack and unpack a message in Java.
Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
any.Unpack(foo)
...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
...
}
The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".
14.4.7.1.1. JSON representation Copy linkLink copied to clipboard!
The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:
package google.profile;
message Person {
string first_name = 1;
string last_name = 2;
}
{
"@type": "type.googleapis.com/google.profile.Person",
"firstName": <string>,
"lastName": <string>
}
If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):
{
"@type": "type.googleapis.com/google.protobuf.Duration",
"value": "1.212s"
}
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| typeUrl | String |
A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in | |||
| value | byte[] | Must be a valid serialized protocol buffer of the above specified type. | byte |
14.4.7.2. RuntimeError Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| error | String | ||||
| code | Integer | int32 | |||
| message | String | ||||
| details | List of ProtobufAny |
14.4.7.3. V1ComplianceControl Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| standardId | String | ||||
| groupId | String | ||||
| name | String | ||||
| description | String | ||||
| implemented | Boolean | ||||
| interpretationText | String |
14.4.7.4. V1ComplianceControlGroup Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| standardId | String | ||||
| name | String | ||||
| description | String | ||||
| numImplementedChecks | Integer | int32 |
14.4.7.5. V1ComplianceStandard Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| metadata | |||||
| groups | List of V1ComplianceControlGroup | ||||
| controls | List of V1ComplianceControl |
14.4.7.6. V1ComplianceStandardMetadata Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| name | String | ||||
| description | String | ||||
| numImplementedChecks | Integer | int32 | |||
| scopes | |||||
| dynamic | Boolean | ||||
| hideScanResults | Boolean |
14.4.7.7. V1ComplianceStandardMetadataScope Copy linkLink copied to clipboard!
| Enum Values |
|---|
| UNSET |
| CLUSTER |
| NAMESPACE |
| DEPLOYMENT |
| NODE |
14.4.7.8. V1GetComplianceStandardResponse Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| standard |
14.5. UpdateComplianceStandardConfig Copy linkLink copied to clipboard!
PATCH /v1/compliance/standards/{id}
14.5.1. Description Copy linkLink copied to clipboard!
14.5.2. Parameters Copy linkLink copied to clipboard!
14.5.2.1. Path Parameters Copy linkLink copied to clipboard!
| Name | Description | Required | Default | Pattern |
|---|---|---|---|---|
| id | X | null |
14.5.2.2. Body Parameter Copy linkLink copied to clipboard!
| Name | Description | Required | Default | Pattern |
|---|---|---|---|---|
| body | X |
14.5.3. Return Type Copy linkLink copied to clipboard!
Object
14.5.4. Content Type Copy linkLink copied to clipboard!
- application/json
14.5.5. Responses Copy linkLink copied to clipboard!
| Code | Message | Datatype |
|---|---|---|
| 200 | A successful response. |
|
| 0 | An unexpected error response. |
14.5.6. Samples Copy linkLink copied to clipboard!
14.5.7. Common object reference Copy linkLink copied to clipboard!
14.5.7.1. ProtobufAny Copy linkLink copied to clipboard!
Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.
Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.
Example 1: Pack and unpack a message in C++.
Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
...
}
Example 2: Pack and unpack a message in Java.
Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
any.Unpack(foo)
...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
...
}
The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".
14.5.7.1.1. JSON representation Copy linkLink copied to clipboard!
The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:
package google.profile;
message Person {
string first_name = 1;
string last_name = 2;
}
{
"@type": "type.googleapis.com/google.profile.Person",
"firstName": <string>,
"lastName": <string>
}
If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):
{
"@type": "type.googleapis.com/google.protobuf.Duration",
"value": "1.212s"
}
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| typeUrl | String |
A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in | |||
| value | byte[] | Must be a valid serialized protocol buffer of the above specified type. | byte |
14.5.7.2. RuntimeError Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| error | String | ||||
| code | Integer | int32 | |||
| message | String | ||||
| details | List of ProtobufAny |
14.5.7.3. V1UpdateComplianceRequest Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | ||||
| hideScanResults | Boolean |